#include <stdio.h>
#include <string.h>
#include <stdlib.h>
main()
{
int a1,a2;
char c1;
char c1c2[100000];
char s[100];
char sp1[100];
char s1[1];
char s2[1];
char s3[1];
gets(c1c2);
strcpy(sp1,c1c2);
c1=c1c2[1]; //glupo resenje ali ne radi kako treba ako se ne uradi ovako
s2[0]=c1;
strcpy(s3,s2); //iz nekog razloga gcc insistira da s2 promeni u "ba" posle scanf tako da mora da se kopira u drugi string
s1[0]=c1c2[0];
scanf("%d %d",&a1,&a2);
if (a1<1||a2>50000)
    return 0;
if (abs(a1-a2)>1)
{
    printf("Nemoguce\n");
    return 0;
}
if (a1==a2)
{
    for (int i=0;i<a1;i++)
    {
        strcat(s,sp1);
    }
}
if (a1>a2)
{
    for (int i=0;i<a2;i++)
    {
        strcat(s,sp1);
    }
    strcat(s,s1);
}
if (a2>a1)
{
    for (int i=0;i<a1;i++)
    {
        strcat(s,sp1);
    }
    strrev(s);
    strcat(s,s3);
}
puts(s);
}